------------------------------------------------------------------------------
--                                                                          --
--                           POLYORB COMPONENTS                             --
--                                                                          --
--                 P O L Y O R B . S E T U P . C L I E N T                  --
--                                                                          --
--                                 B o d y                                  --
--                                                                          --
--         Copyright (C) 2001-2007, Free Software Foundation, Inc.          --
--                                                                          --
-- PolyORB is free software; you  can  redistribute  it and/or modify it    --
-- under terms of the  GNU General Public License as published by the  Free --
-- Software Foundation;  either version 2,  or (at your option)  any  later --
-- version. PolyORB is distributed  in the hope that it will be  useful,    --
-- but WITHOUT ANY WARRANTY;  without even the implied warranty of MERCHAN- --
-- TABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public --
-- License  for more details.  You should have received  a copy of the GNU  --
-- General Public License distributed with PolyORB; see file COPYING. If    --
-- not, write to the Free Software Foundation, 51 Franklin Street, Fifth    --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
--                                                                          --
--                  PolyORB is maintained by AdaCore                        --
--                     (email: sales@adacore.com)                           --
--                                                                          --
------------------------------------------------------------------------------

--  Set up a simple ORB to act as a client

pragma Style_Checks ("M2048");
--  Configure substitutions may yield long lines
--  src/setup/polyorb-setup-client.adb.  Generated from polyorb-setup-client.adb.in by configure.

with PolyORB.Setup.Base;
pragma Warnings (Off, PolyORB.Setup.Base);
pragma Elaborate_All (PolyORB.Setup.Base);

with PolyORB.Setup.Tasking.No_Tasking;
pragma Warnings (Off, PolyORB.Setup.Tasking.No_Tasking);
pragma Elaborate_All (PolyORB.Setup.Tasking.No_Tasking);

with PolyORB.ORB.No_Tasking;
pragma Warnings (Off, PolyORB.ORB.No_Tasking);
pragma Elaborate_All (PolyORB.ORB.No_Tasking);

with PolyORB.ORB_Controller.No_Tasking;
pragma Warnings (Off, PolyORB.ORB_Controller.No_Tasking);
pragma Elaborate_All (PolyORB.ORB_Controller.No_Tasking);

--  Personalities setup
----------
-- GIOP --
----------

with PolyORB.Setup.DIOP;
pragma Elaborate_All (PolyORB.Setup.DIOP);
pragma Warnings (Off, PolyORB.Setup.DIOP);

with PolyORB.Setup.IIOP;
pragma Elaborate_All (PolyORB.Setup.IIOP);
pragma Warnings (Off, PolyORB.Setup.IIOP);

--  with PolyORB.Setup.SSLIOP;
--  pragma Elaborate_All (PolyORB.Setup.SSLIOP);
--  pragma Warnings (Off, PolyORB.Setup.SSLIOP);

with PolyORB.Setup.UIPMC;
pragma Elaborate_All (PolyORB.Setup.UIPMC);
pragma Warnings (Off, PolyORB.Setup.UIPMC);

with PolyORB.Binding_Data.GIOP.DIOP;
pragma Elaborate_All (PolyORB.Binding_Data.GIOP.DIOP);
pragma Warnings (Off, PolyORB.Binding_Data.GIOP.DIOP);

with PolyORB.Binding_Data.GIOP.IIOP;
pragma Elaborate_All (PolyORB.Binding_Data.GIOP.IIOP);
pragma Warnings (Off, PolyORB.Binding_Data.GIOP.IIOP);

with PolyORB.Binding_Data.GIOP.UIPMC;
pragma Elaborate_All (PolyORB.Binding_Data.GIOP.UIPMC);
pragma Warnings (Off, PolyORB.Binding_Data.GIOP.UIPMC);

with PolyORB.Binding_Data.GIOP.INET;
pragma Elaborate_All (PolyORB.Binding_Data.GIOP.INET);
pragma Warnings (Off, PolyORB.Binding_Data.GIOP.INET);

with PolyORB.Binding_Data.GIOP;
pragma Elaborate_All (PolyORB.Binding_Data.GIOP);
pragma Warnings (Off, PolyORB.Binding_Data.GIOP);

package body PolyORB.Setup.Client is
end PolyORB.Setup.Client;
