------------------------------------------------------------------------------
--                                                                          --
--                           POLYORB COMPONENTS                             --
--                                                                          --
--                 P O L Y O R B . S E T U P . S E R V E R                  --
--                                                                          --
--                                 B o d y                                  --
--                                                                          --
--         Copyright (C) 2001-2007, Free Software Foundation, Inc.          --
--                                                                          --
-- PolyORB is free software; you  can  redistribute  it and/or modify it    --
-- under terms of the  GNU General Public License as published by the  Free --
-- Software Foundation;  either version 2,  or (at your option)  any  later --
-- version. PolyORB is distributed  in the hope that it will be  useful,    --
-- but WITHOUT ANY WARRANTY;  without even the implied warranty of MERCHAN- --
-- TABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public --
-- License  for more details.  You should have received  a copy of the GNU  --
-- General Public License distributed with PolyORB; see file COPYING. If    --
-- not, write to the Free Software Foundation, 51 Franklin Street, Fifth    --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
--                                                                          --
--                  PolyORB is maintained by AdaCore                        --
--                     (email: sales@adacore.com)                           --
--                                                                          --
------------------------------------------------------------------------------

--  Set up a simple ORB to act as a server

--  The user must take care of also setting up a tasking runtime and a
--  ORB tasking policy.

pragma Style_Checks ("M2048");
--  Configure substitutions may yield long lines
--  src/setup/polyorb-setup-server.adb.  Generated from polyorb-setup-server.adb.in by configure.

with PolyORB.Setup.Base;
pragma Warnings (Off, PolyORB.Setup.Base);
pragma Elaborate_All (PolyORB.Setup.Base);

with PolyORB.Setup.OA.Basic_POA;
pragma Warnings (Off, PolyORB.Setup.OA.Basic_POA);
pragma Elaborate_All (PolyORB.Setup.OA.Basic_POA);

--  Personalities setup
----------
-- GIOP --
----------

with PolyORB.Setup.DIOP;
pragma Elaborate_All (PolyORB.Setup.DIOP);
pragma Warnings (Off, PolyORB.Setup.DIOP);

with PolyORB.Setup.IIOP;
pragma Elaborate_All (PolyORB.Setup.IIOP);
pragma Warnings (Off, PolyORB.Setup.IIOP);

--  with PolyORB.Setup.SSLIOP;
--  pragma Elaborate_All (PolyORB.Setup.SSLIOP);
--  pragma Warnings (Off, PolyORB.Setup.SSLIOP);

with PolyORB.Setup.UIPMC;
pragma Elaborate_All (PolyORB.Setup.UIPMC);
pragma Warnings (Off, PolyORB.Setup.UIPMC);

with PolyORB.Setup.Access_Points.DIOP;
pragma Elaborate_All (PolyORB.Setup.Access_Points.DIOP);
pragma Warnings (Off, PolyORB.Setup.Access_Points.DIOP);

with PolyORB.Setup.Access_Points.IIOP;
pragma Elaborate_All (PolyORB.Setup.Access_Points.IIOP);
pragma Warnings (Off, PolyORB.Setup.Access_Points.IIOP);

--  with PolyORB.Setup.Access_Points.SSLIOP;
--  pragma Elaborate_All (PolyORB.Setup.Access_Points.SSLIOP);
--  pragma Warnings (Off, PolyORB.Setup.Access_Points.SSLIOP);

with PolyORB.Setup.Access_Points.UIPMC;
pragma Elaborate_All (PolyORB.Setup.Access_Points.UIPMC);
pragma Warnings (Off, PolyORB.Setup.Access_Points.UIPMC);

package body PolyORB.Setup.Server is
end PolyORB.Setup.Server;
