------------------------------------------------------------------------------
--                                                                          --
--                           POLYORB COMPONENTS                             --
--                                                                          --
--           P O L Y O R B . U T I L S . T E X T _ B U F F E R S            --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--         Copyright (C) 2001-2008, Free Software Foundation, Inc.          --
--                                                                          --
-- PolyORB is free software; you  can  redistribute  it and/or modify it    --
-- under terms of the  GNU General Public License as published by the  Free --
-- Software Foundation;  either version 2,  or (at your option)  any  later --
-- version. PolyORB is distributed  in the hope that it will be  useful,    --
-- but WITHOUT ANY WARRANTY;  without even the implied warranty of MERCHAN- --
-- TABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public --
-- License  for more details.  You should have received  a copy of the GNU  --
-- General Public License distributed with PolyORB; see file COPYING. If    --
-- not, write to the Free Software Foundation, 51 Franklin Street, Fifth    --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
--                                                                          --
--                  PolyORB is maintained by AdaCore                        --
--                     (email: sales@adacore.com)                           --
--                                                                          --
------------------------------------------------------------------------------

--  Utility functions for storing strings into buffers and retrieving them

with PolyORB.Buffers; use PolyORB.Buffers;

package PolyORB.Utils.Text_Buffers is

   pragma Elaborate_Body;

   procedure Marshall_Char (B : access Buffer_Type; C : Character);
   --  Marshall one character

   function Unmarshall_Char (B : access Buffer_Type) return Character;
   --  Unmarshall one character

   procedure Marshall_String (B : access Buffer_Type; S : String);
   --  Marshall a string

   procedure Unmarshall_String (B : access Buffer_Type; S : out String);
   --  Unmarshall a string

end PolyORB.Utils.Text_Buffers;
